/* File: gosiv_path.cc

* Copyright (c) 2003 James A. Strother
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*/

#include "gosiv_path.h"

gosiv_path::gosiv_path()
{
}

gosiv_path::~gosiv_path()
{
}

bool gosiv_path::empty()
{
  return q.empty();
}

void gosiv_path::push(int n)
{
  gosiv_node node;

  node.type = GOSIV_PATH_OP;
  node.ptr = malloc(sizeof(int));
  *((int*)(node.ptr)) = n;
		    
  q.push(node);
}

int gosiv_path::popOp()
{
  gosiv_node node;

  node = q.front();
  assert(node.type == GOSIV_PATH_OP);
  int r = *((int*)(node.ptr));
  q.pop();
    
  return r;
}

void gosiv_path::push(const gosiv_point& pt)
{
  gosiv_node node;

  node.type = GOSIV_PATH_PT;
  node.ptr = malloc(sizeof(gosiv_point));
  *((gosiv_point*)(node.ptr)) = pt;

  q.push(node);
}

gosiv_point gosiv_path::popPt()
{
  gosiv_node node;

  node = q.front();
  assert(node.type == GOSIV_PATH_PT);
  gosiv_point r = *((gosiv_point*)(node.ptr));
  q.pop();

  return r;
}

